/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {
};
RE.isDragging = false;
RE.init = function() {
    // Make sure that when we tap anywhere in the document we focus on the editor
    $(window).on('touchmove', function(e) {
                 RE.isDragging = true;
                 });
    $(window).on('touchstart', function(e) {
                 RE.isDragging = false;
                 });
    $(window).on('touchend', function(e) {
        if (!RE.isDragging){
            if(e.target.nodeName.toLowerCase() == "img"){
//                RE.currentEditContent = e.target;
                var src = 'zss-img:' + e.target.src;
                 android.showHrefUrl(src);
//                window.webkit.messageHandlers.EduMessageHandler.postMessage(src);
  //              RE.focusTextEditor(e.target);
            }else if(e.target.nodeName.toLowerCase() == "a"){
//                RE.currentEditContent = e.target;
                var href = e.target.href;
                android.showHrefUrl(href);
//                window.webkit.messageHandlers.EduMessageHandler.postMessage('showLink:' + href);
//              RE.focusTextEditor(e.target);
            }
        }
    });
}//end

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');
RE.currentEditingLink ;


// The current editing image
RE.currentEditingImage;

// The current editing link


document.addEventListener("selectionchange", function() {

var selection = window.getSelection();
    if (selection.rangeCount > 0) {
     var text = "";
        if (window.getSelection) {
            text = window.getSelection().toString();
        } else if (document.selection && document.selection.type != "Control") {
            text = document.selection.createRange().text;
        }
        if("" != text){
           android.selectText("true");
        }
    }else{

    }
 });

//const link = document.querySelector('a');
//link.addEventListener('click', function(event) {
//  event.preventDefault(); // 阻止默认的链接跳转行为
//  android.showHrefUrl(link.attr('href'));
//});
 document.addEventListener("click",  function(e){
  if(e.target.nodeName.toLowerCase() == "img"){
 //                RE.currentEditContent = e.target;
                 var src = 'zss-img:' + e.target.src;
                  android.showHrefUrl(src);
 //                window.webkit.messageHandlers.EduMessageHandler.postMessage(src);
   //              RE.focusTextEditor(e.target);
             }else if(e.target.nodeName.toLowerCase() == "a"){
 //                RE.currentEditContent = e.target;
                 var href = e.target.href;
                 android.showHrefUrl(href);
 //                window.webkit.messageHandlers.EduMessageHandler.postMessage('showLink:' + href);
 //              RE.focusTextEditor(e.target);
             }else{
 android.cancelSelect("true");
 }

 });



// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURI(RE.getHtml());
}

RE.pasteCallback = function() {
    window.location.href = "paste-callback://" + encodeURI(RE.getHtml());
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = contents;
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}
RE.getContent = function() {
    return $('#editor').text();
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setLetterSpacing = function(size) {
    RE.editor.style.lineHeight = size;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
}

RE.setTextColor = function(color) {
      RE.restorerange();
      document.execCommand("styleWithCSS", null, true);
      document.execCommand('foreColor', false, color);
      document.execCommand("styleWithCSS", null, false);
      RE.enabledEditingItems();
//      document.execCommand("removeFormat", false, "foreColor");
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}
RE.insertImage = function(url, alt,width,height) {
    var html = '<img src="' + url + '" alt="' + alt + '" width = "'+width+'" height = "'+height+'" />';
    RE.insertHTML(html);
}
RE.insertImage = function(url, alt) {
    var html = '<img src="' + url + '" alt="' + alt + '" />';
    RE.insertHTML(html);
}

RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);



}
RE.isCommandEnabled = function(commandName) {
    return document.queryCommandState(commandName);
}

RE.enabledEditingItems = function(e) {
     var items = [];
        if (RE.isCommandEnabled('bold')) {
            items.push('bold');
        }
        if (RE.isCommandEnabled('italic')) {
            items.push('italic');
        }
        if (RE.isCommandEnabled('subscript')) {
            items.push('subscript');
        }
        if (RE.isCommandEnabled('superscript')) {
            items.push('superscript');
        }
        if (RE.isCommandEnabled('strikeThrough')) {
            items.push('strikeThrough');
        }
        if (RE.isCommandEnabled('underline')) {
            items.push('underline');
        }
        if (RE.isCommandEnabled('insertOrderedList')) {
            items.push('orderedList');
        }
        if (RE.isCommandEnabled('insertUnorderedList')) {
            items.push('unorderedList');
        }
        if (RE.isCommandEnabled('justifyCenter')) {
            items.push('justify');
        }
        if (RE.isCommandEnabled('justifyFull')) {
            items.push('justify');
        }
        if (RE.isCommandEnabled('justifyLeft')) {
            items.push('justify');
        }
        if (RE.isCommandEnabled('justifyRight')) {
            items.push('justify');
        }
        if (RE.isCommandEnabled('insertHorizontalRule')) {
            items.push('horizontalRule');
        }
        var formatBlock = document.queryCommandValue('formatBlock');
        if (formatBlock.length > 0) {
            items.push(formatBlock);
        }
        if (typeof(e) != "undefined") {
            // The target element
            var s = RE.getSelectedNode();
            var t = $(s);
            var nodeName = e.target.nodeName.toLowerCase();

            // Background Color
            var bgColor = t.css('backgroundColor');
            if (bgColor.length != 0 && bgColor != 'rgba(0, 0, 0, 0)' && bgColor != 'rgb(0, 0, 0)' && bgColor != 'transparent') {
                items.push('backgroundColor');
            }
            // Text Color
            var textColor = t.css('color');
            if (textColor.length != 0 && textColor != 'rgba(0, 0, 0, 0)' && textColor != 'rgb(0, 0, 0)' && textColor != 'transparent') {
                items.push('textColor:' + textColor);
            }
    		//Fonts
            var fontSize = t.css('font-size');
            if (fontSize.length != 0) {
                items.push('fontSize:' + fontSize);
            }
    		var font = t.css('font-family');
    		if (font.length != 0 && font != 'Arial, Helvetica, sans-serif') {
    			items.push('fonts');
    		}
            // Link
            if (nodeName == 'a') {
                RE.currentEditingLink = t;
                var title = t.attr('title');
                items.push('link:'+t.attr('href'));
                if (t.attr('title') !== undefined) {
                    items.push('link-title:'+t.attr('title'));
                }
            } else {
                RE.currentEditingLink = null;
            }
            // Blockquote
            if (nodeName == 'blockquote') {
                items.push('indent');
            }
            // Image
            if (nodeName == 'img') {
                RE.currentEditingImage = t;
                items.push('image:'+t.attr('src'));
                if (t.attr('alt') !== undefined) {
                    items.push('image-alt:'+t.attr('alt'));
                }
            } else {
                RE.currentEditingImage = null;
            }
        }
        window.location.href = "re-state://" + encodeURI(items.join(','));

}

RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("paste", RE.pasteCallback);
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems(e);
    }
});






